// example of incorporation of C++ into python using boost-python
//

#include <boost/python.hpp>
#include <cmath>


std::string greet(const char * name)
{
  printf("\n%s\n", name);
  std::string a(name);
  return a;
}

int square(int value)
{
  return value*value;
}

double myerf(double value)
{
  return erf(value);
}

double listerf(boost::python::list& ns)
{
  double x=0.0;
  for (int i = 0; i < len(ns); ++i)
    {
        x += erf(boost::python::extract<double>(ns[i]));
    }
  return x;
}


namespace python = boost::python;

BOOST_PYTHON_MODULE(hello)
{
  python::def("greet",greet);
  python::def("square",square);
  python::def("erf",myerf);
  python::def("listerf",listerf);
}
